Attribute VB_Name = "basCode"
Option Explicit

Sub SaveMessageToWord()
'Created by Helen Feddema 3-25-2002
'Last modified 3-25-2002

On Error GoTo ErrorHandler

   Dim appWord As Word.Application
   Dim ins As Outlook.Inspector
   Dim msg As Outlook.MailItem
   Dim strMessage As String
   Dim docs As Word.Documents
   Dim prps As Object
   Dim strDocument As String
   Dim strTemplateDir As String
   
   'Create a new document from the Word template
   Set appWord = GetObject(, "Word.Application")
   strTemplateDir = appWord.Options.DefaultFilePath(wdUserTemplatesPath)
   Debug.Print "Office templates directory: " & strTemplateDir
   strDocument = strTemplateDir & "\Outlook Mail.dot"
   Debug.Print "Document: " & strDocument
   
   Set docs = appWord.Documents
   docs.Add strDocument
   
   Set prps = appWord.ActiveDocument.CustomDocumentProperties
   
   'Determine whether an Outlook item is open in an Inspector
   Set ins = Application.ActiveInspector
   If ins Is Nothing Then
      strMessage = "No Outlook item is open; can't import mail"
      MsgBox strMessage
      appWord.ActiveDocument.Close (False)
      GoTo ErrorHandlerExit
   Else
      Debug.Print "Current item class: " & ins.CurrentItem.Class
   End If
   
   'Determine class of currently open Outlook item
   If ins.CurrentItem.Class <> olMail Then
      'Current item is not a mail item
      strMessage = "No mail item is open; exiting"
      MsgBox strMessage
      appWord.ActiveDocument.Close (False)
      GoTo ErrorHandlerExit
   ElseIf ins.CurrentItem.Class = olMail Then
      'Current item is a mail item; save data to doc properties
      Set msg = ins.CurrentItem
      prps.Item("MailSubject") = msg.Subject
      If Len(msg.Body) <= 127 Then
         prps.Item("Body") = msg.Body
      Else
         appWord.Selection.GoTo what:=wdGoToBookmark, Name:="Body"
         appWord.Selection.TypeText Text:=msg.Body
      End If
      prps.Item("CC") = msg.CC
      prps.Item("BCC") = msg.BCC
      prps.Item("Sent") = msg.SentOn
      prps.Item("From") = msg.SenderName
      prps.Item("Categories") = msg.Categories
      appWord.Selection.WholeStory
      appWord.Selection.Fields.Update
      appWord.Selection.EndKey Unit:=wdStory
   End If

ErrorHandlerExit:
   Exit Sub

ErrorHandler:
   If Err.Number = 91 Then
      strMessage = "No mail message is open; can't import mail"
      MsgBox strMessage
      appWord.ActiveDocument.Close (False)
      GoTo ErrorHandlerExit
   Else
      MsgBox "Error No: " & Err.Number & "; Description: " & Err.Description
   End If
   Resume ErrorHandlerExit

End Sub

